/*  -*- Mode: C -*- 
 * This file is part of my project
 * 
 * declare.h -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Tue May  9 00:48:11 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Tue May  9 00:48:12 1995
 * description:
 * 
 * history:
 *   programming by NBC02365@niftyserve.or.jp
 */

/* error.c */
void grammer(char *s);
void nu_error(char *msg, ...);
void nu_warning(char *msg, ...);
void nu_fatal(char *msg, ...);
/* expr.c */
expr_t nil(void);
expr_t mk_char(char *s);
expr_t mk_integer(integer_t i);
expr_t mk_expr(expr_t a, expr_t b);
expr_t mk_string(char *s);
expr_t mk_ident(char *s);
expr_t mk_sym(integer_t s);
expr_t mk_op(integer_t op);
expr_t mk_name(char *s);
void expr_reset(void);
void expr_init(void);
pointer xreverse(pointer term, pointer list);
pointer xcons(pointer a, pointer b);
pointer xappend(pointer c, pointer d);
integer_t xlength(pointer p);
void expr_print(pointer p);
/* init.c */
void nu_init(void);
void nu_finish(void);
/* int.c */
boolean ident_p(expr_t e);
void assert_ident(expr_t e);
void assert_ident1(expr_t e, char *s);
pointer interp_if(pointer p);
pointer interp_while(pointer p);
pointer interp_proc(pointer p);
pointer interp_lambda(pointer p);
pointer interp_break(pointer p);
pointer interp_continue(pointer p);
pointer interp_declare(pointer p);
pointer interp_define(pointer p);
pointer interp_block(pointer p);
pointer interp_prim(pointer p);
pointer interp_exit(pointer p);
pointer interp_begin(pointer p);
pointer interp_or(pointer p);
pointer interp_and(pointer p);
pointer interp_macro(pointer p);
expr_t interp(expr_t p);
boolean nu_source(char *fname);
void *name_value(char *name);
/* name.c */
name_t search_name(expr_t ident);
name_t intern_name(expr_t ident);
/* readexpr.c */
void nu_set_input(FILE *fp);
pointer readexpr(void);
boolean nu_eof(pointer p);
/* test.c */
int main(void);
/* xmalloc.c */
char *nu_malloc(register unsigned long size);
char *nu_calloc(register unsigned long size);
char *nu_realloc(register char *p, register unsigned long size);
void nu_free(char *p);
